# frozen_string_literal: true
require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe MeetingsController, type: :controller do
  # This should return the minimal set of attributes required to create a valid
  # Meeting. As you add validations to Meeting, be sure to
  # adjust the attributes here as well.
  let(:committee) { create(:committee) }
  let!(:meeting) { create(:meeting, committee: committee, approved: true) }
  let!(:meeting2) { create(:meeting, committee: committee) }
  let!(:meeting3) { create(:meeting, :past, committee: committee, approved: true) }
  let!(:meeting4) { create(:meeting, :past, committee: committee, approved: false) }

  let(:invalid_attributes) do
    attributes_for(:meeting, name: nil)
  end

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # MeetingsController. Be sure to keep this updated too.
  let(:valid_session) do
    { user_id: { 'uid' => create(:user).uid, 'extra' => {},
                 'credentials' => { 'expires_at' => 1.hour.from_now.to_i } } }
  end

  before { cookies[:sso_session] = 'sso_session_random_key' }

  describe 'GET #index' do
    context 'given valid session' do
      it 'assigns all meetings as @meetings' do
        get :index, params: { committee_id: committee.id }, session: valid_session
        expect(assigns(:meetings)).to eq([meeting, meeting2])
      end

      context 'given presenter params' do
        it 'assigns all past meetings' do
          get :index, params: { committee_id: committee.id, scopes: [:past] },
                      session: valid_session
          expect(assigns(:meetings)).to eq([meeting3, meeting4])
        end

        it 'assigns all meetings as @meetings' do
          get :index, params: { committee_id: committee.id, scopes: [:all] }, session: valid_session
          expect(assigns(:meetings)).to match(Meeting.all)
        end
      end
    end

    context 'given anonymous session' do
      it 'assigns only approved future meetings' do
        get :index, params: { committee_id: committee.id }, session: {}
        expect(assigns(:meetings)).to eq([meeting])
      end

      context 'given presenter params' do
        it 'assigns past meetings' do
          get :index, params: { committee_id: committee.id, scopes: [:past] }, session: {}
          expect(assigns(:meetings)).to eq([meeting3])
        end

        it 'assigns all meetings as @meetings' do
          get :index, params: { committee_id: committee.id, scopes: [:all] }, session: {}
          expect(assigns(:meetings)).to match(Meeting.approved)
        end
      end
    end
  end

  describe 'GET #show' do
    it 'assigns the requested meeting as @meeting' do
      get :show, params: { committee_id: meeting.committee.id, id: meeting.to_param },
                 session: valid_session
      expect(assigns(:meeting)).to eq(meeting)
    end
  end

  describe 'GET #new' do
    it 'assigns a new meeting as @meeting' do
      get :new, params: { committee_id: committee.id }, session: valid_session
      expect(assigns(:meeting)).to be_a_new(Meeting)
    end
  end

  describe 'GET #edit' do
    it 'assigns the requested meeting as @meeting' do
      get :edit, params: { committee_id: meeting.committee.id, id: meeting.to_param },
                 session: valid_session
      expect(assigns(:meeting)).to eq(meeting)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      it 'creates a new Meeting' do
        expect do
          post :create, params: { committee_id: committee.id,
                                  meeting: attributes_for(:meeting) },
                        session: valid_session
        end.to change(Meeting, :count).by(1)
      end

      it 'assigns a newly created meeting as @meeting' do
        post :create, params: { committee_id: committee.id, meeting: attributes_for(:meeting) },
                      session: valid_session
        expect(assigns(:meeting)).to be_a(Meeting)
        expect(assigns(:meeting)).to be_persisted
      end

      it 'redirects to the created meeting' do
        post :create, params: { committee_id: committee.id, meeting: attributes_for(:meeting) },
                      session: valid_session
        expect(response).to redirect_to([committee, Meeting.unscoped.last])
      end
    end

    context 'with invalid params' do
      it 'assigns a newly created but unsaved meeting as @meeting' do
        post :create, params: { committee_id: committee.id, meeting: invalid_attributes },
                      session: valid_session
        expect(assigns(:meeting)).to be_a_new(Meeting)
      end

      it "re-renders the 'new' template" do
        post :create, params: { committee_id: meeting.committee.id, meeting: invalid_attributes },
                      session: valid_session
        expect(response).to render_template('new')
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) do
        attributes_for(:meeting, name: 'some meeting name edited')
      end

      it 'updates the requested meeting' do
        put :update, params: { committee_id: meeting.committee.id, id: meeting.to_param,
                               meeting: new_attributes },
                     session: valid_session
        meeting.reload
        expect(meeting.name).to eq('some meeting name edited')
      end

      it 'assigns the requested meeting as @meeting' do
        put :update, params: { committee_id: meeting.committee.id, id: meeting.to_param,
                               meeting: attributes_for(:meeting) },
                     session: valid_session
        expect(assigns(:meeting)).to eq(meeting)
      end

      it 'redirects to the meeting' do
        put :update, params: { committee_id: meeting.committee.id,
                               id: meeting.to_param, meeting: attributes_for(:meeting) },
                     session: valid_session
        expect(response).to redirect_to([meeting.committee, meeting])
      end
    end

    context 'with invalid params' do
      it 'assigns the meeting as @meeting' do
        put :update, params: { committee_id: meeting.committee.id, id: meeting.to_param,
                               meeting: invalid_attributes },
                     session: valid_session
        expect(assigns(:meeting)).to eq(meeting)
      end

      it "re-renders the 'edit' template" do
        put :update, params: { committee_id: meeting.committee.id, id: meeting.to_param,
                               meeting: invalid_attributes },
                     session: valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    before(:each) { create(:meeting) }

    it 'destroys the requested meeting' do
      expect do
        delete :destroy, params: { committee_id: Meeting.last.committee.id,
                                   id: Meeting.last.to_param },
                         session: valid_session
      end.to change(Meeting, :count).by(-1)
    end

    it 'redirects to the meetings list' do
      delete :destroy, params: { committee_id: Meeting.last.committee.id,
                                 id: Meeting.last.to_param }, session: valid_session
      expect(response).to redirect_to(committee_meetings_url)
    end
  end
end
